/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */

package com.ajp.portal.model.impl;

import aQute.bnd.annotation.ProviderType;

import com.ajp.portal.model.LegalCase;
import com.ajp.portal.model.LegalCaseModel;

import com.liferay.expando.kernel.model.ExpandoBridge;
import com.liferay.expando.kernel.util.ExpandoBridgeFactoryUtil;
import com.liferay.exportimport.kernel.lar.StagedModelType;
import com.liferay.portal.kernel.bean.AutoEscapeBeanHandler;
import com.liferay.portal.kernel.exception.PortalException;
import com.liferay.portal.kernel.model.CacheModel;
import com.liferay.portal.kernel.model.ModelWrapper;
import com.liferay.portal.kernel.model.User;
import com.liferay.portal.kernel.model.impl.BaseModelImpl;
import com.liferay.portal.kernel.service.ServiceContext;
import com.liferay.portal.kernel.service.UserLocalServiceUtil;
import com.liferay.portal.kernel.util.DateUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.PortalUtil;
import com.liferay.portal.kernel.util.ProxyUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.workflow.WorkflowConstants;

import java.io.Serializable;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationHandler;

import java.sql.Types;

import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.function.Function;

/**
 * The base model implementation for the LegalCase service. Represents a row in the &quot;ajp_LegalCase&quot; database table, with each column mapped to a property of this class.
 *
 * <p>
 * This implementation and its corresponding interface </code>LegalCaseModel</code> exist only as a container for the default property accessors generated by ServiceBuilder. Helper methods and all application logic should be put in {@link LegalCaseImpl}.
 * </p>
 *
 * @author Brian Wing Shun Chan
 * @see LegalCaseImpl
 * @generated
 */
@ProviderType
public class LegalCaseModelImpl
	extends BaseModelImpl<LegalCase> implements LegalCaseModel {

	/*
	 * NOTE FOR DEVELOPERS:
	 *
	 * Never modify or reference this class directly. All methods that expect a legal case model instance should use the <code>LegalCase</code> interface instead.
	 */
	public static final String TABLE_NAME = "ajp_LegalCase";

	public static final Object[][] TABLE_COLUMNS = {
		{"uuid_", Types.VARCHAR}, {"legalCaseId", Types.BIGINT},
		{"groupId", Types.BIGINT}, {"companyId", Types.BIGINT},
		{"userId", Types.BIGINT}, {"userName", Types.VARCHAR},
		{"createDate", Types.TIMESTAMP}, {"modifiedDate", Types.TIMESTAMP},
		{"status", Types.INTEGER}, {"statusByUserId", Types.BIGINT},
		{"statusByUserName", Types.VARCHAR}, {"statusDate", Types.TIMESTAMP},
		{"title", Types.VARCHAR}, {"description", Types.VARCHAR},
		{"decisionDate", Types.TIMESTAMP}, {"countryCategoryId", Types.BIGINT},
		{"subareaCategoryId", Types.BIGINT},
		{"summaryFileEntryId", Types.BIGINT},
		{"judgementFileEntryId", Types.BIGINT}, {"url", Types.VARCHAR}
	};

	public static final Map<String, Integer> TABLE_COLUMNS_MAP =
		new HashMap<String, Integer>();

	static {
		TABLE_COLUMNS_MAP.put("uuid_", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("legalCaseId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("groupId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("companyId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("userName", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("createDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("modifiedDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("status", Types.INTEGER);
		TABLE_COLUMNS_MAP.put("statusByUserId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("statusByUserName", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("statusDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("title", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("description", Types.VARCHAR);
		TABLE_COLUMNS_MAP.put("decisionDate", Types.TIMESTAMP);
		TABLE_COLUMNS_MAP.put("countryCategoryId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("subareaCategoryId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("summaryFileEntryId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("judgementFileEntryId", Types.BIGINT);
		TABLE_COLUMNS_MAP.put("url", Types.VARCHAR);
	}

	public static final String TABLE_SQL_CREATE =
		"create table ajp_LegalCase (uuid_ VARCHAR(75) null,legalCaseId LONG not null primary key,groupId LONG,companyId LONG,userId LONG,userName VARCHAR(75) null,createDate DATE null,modifiedDate DATE null,status INTEGER,statusByUserId LONG,statusByUserName VARCHAR(75) null,statusDate DATE null,title VARCHAR(255) null,description TEXT null,decisionDate DATE null,countryCategoryId LONG,subareaCategoryId LONG,summaryFileEntryId LONG,judgementFileEntryId LONG,url VARCHAR(1000) null)";

	public static final String TABLE_SQL_DROP = "drop table ajp_LegalCase";

	public static final String ORDER_BY_JPQL =
		" ORDER BY legalCase.decisionDate DESC";

	public static final String ORDER_BY_SQL =
		" ORDER BY ajp_LegalCase.decisionDate DESC";

	public static final String DATA_SOURCE = "liferayDataSource";

	public static final String SESSION_FACTORY = "liferaySessionFactory";

	public static final String TX_MANAGER = "liferayTransactionManager";

	public static final boolean ENTITY_CACHE_ENABLED = GetterUtil.getBoolean(
		com.ajp.portal.service.util.ServiceProps.get(
			"value.object.entity.cache.enabled.com.ajp.portal.model.LegalCase"),
		true);

	public static final boolean FINDER_CACHE_ENABLED = GetterUtil.getBoolean(
		com.ajp.portal.service.util.ServiceProps.get(
			"value.object.finder.cache.enabled.com.ajp.portal.model.LegalCase"),
		true);

	public static final boolean COLUMN_BITMASK_ENABLED = GetterUtil.getBoolean(
		com.ajp.portal.service.util.ServiceProps.get(
			"value.object.column.bitmask.enabled.com.ajp.portal.model.LegalCase"),
		true);

	public static final long COMPANYID_COLUMN_BITMASK = 1L;

	public static final long COUNTRYCATEGORYID_COLUMN_BITMASK = 2L;

	public static final long GROUPID_COLUMN_BITMASK = 4L;

	public static final long SUBAREACATEGORYID_COLUMN_BITMASK = 8L;

	public static final long UUID_COLUMN_BITMASK = 16L;

	public static final long DECISIONDATE_COLUMN_BITMASK = 32L;

	public static final long LOCK_EXPIRATION_TIME = GetterUtil.getLong(
		com.ajp.portal.service.util.ServiceProps.get(
			"lock.expiration.time.com.ajp.portal.model.LegalCase"));

	public LegalCaseModelImpl() {
	}

	@Override
	public long getPrimaryKey() {
		return _legalCaseId;
	}

	@Override
	public void setPrimaryKey(long primaryKey) {
		setLegalCaseId(primaryKey);
	}

	@Override
	public Serializable getPrimaryKeyObj() {
		return _legalCaseId;
	}

	@Override
	public void setPrimaryKeyObj(Serializable primaryKeyObj) {
		setPrimaryKey(((Long)primaryKeyObj).longValue());
	}

	@Override
	public Class<?> getModelClass() {
		return LegalCase.class;
	}

	@Override
	public String getModelClassName() {
		return LegalCase.class.getName();
	}

	@Override
	public Map<String, Object> getModelAttributes() {
		Map<String, Object> attributes = new HashMap<String, Object>();

		Map<String, Function<LegalCase, Object>> attributeGetterFunctions =
			getAttributeGetterFunctions();

		for (Map.Entry<String, Function<LegalCase, Object>> entry :
				attributeGetterFunctions.entrySet()) {

			String attributeName = entry.getKey();
			Function<LegalCase, Object> attributeGetterFunction =
				entry.getValue();

			attributes.put(
				attributeName, attributeGetterFunction.apply((LegalCase)this));
		}

		attributes.put("entityCacheEnabled", isEntityCacheEnabled());
		attributes.put("finderCacheEnabled", isFinderCacheEnabled());

		return attributes;
	}

	@Override
	public void setModelAttributes(Map<String, Object> attributes) {
		Map<String, BiConsumer<LegalCase, Object>> attributeSetterBiConsumers =
			getAttributeSetterBiConsumers();

		for (Map.Entry<String, Object> entry : attributes.entrySet()) {
			String attributeName = entry.getKey();

			BiConsumer<LegalCase, Object> attributeSetterBiConsumer =
				attributeSetterBiConsumers.get(attributeName);

			if (attributeSetterBiConsumer != null) {
				attributeSetterBiConsumer.accept(
					(LegalCase)this, entry.getValue());
			}
		}
	}

	public Map<String, Function<LegalCase, Object>>
		getAttributeGetterFunctions() {

		return _attributeGetterFunctions;
	}

	public Map<String, BiConsumer<LegalCase, Object>>
		getAttributeSetterBiConsumers() {

		return _attributeSetterBiConsumers;
	}

	private static Function<InvocationHandler, LegalCase>
		_getProxyProviderFunction() {

		Class<?> proxyClass = ProxyUtil.getProxyClass(
			LegalCase.class.getClassLoader(), LegalCase.class,
			ModelWrapper.class);

		try {
			Constructor<LegalCase> constructor =
				(Constructor<LegalCase>)proxyClass.getConstructor(
					InvocationHandler.class);

			return invocationHandler -> {
				try {
					return constructor.newInstance(invocationHandler);
				}
				catch (ReflectiveOperationException roe) {
					throw new InternalError(roe);
				}
			};
		}
		catch (NoSuchMethodException nsme) {
			throw new InternalError(nsme);
		}
	}

	private static final Map<String, Function<LegalCase, Object>>
		_attributeGetterFunctions;
	private static final Map<String, BiConsumer<LegalCase, Object>>
		_attributeSetterBiConsumers;

	static {
		Map<String, Function<LegalCase, Object>> attributeGetterFunctions =
			new LinkedHashMap<String, Function<LegalCase, Object>>();
		Map<String, BiConsumer<LegalCase, ?>> attributeSetterBiConsumers =
			new LinkedHashMap<String, BiConsumer<LegalCase, ?>>();

		attributeGetterFunctions.put(
			"uuid",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getUuid();
				}

			});
		attributeSetterBiConsumers.put(
			"uuid",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object uuid) {
					legalCase.setUuid((String)uuid);
				}

			});
		attributeGetterFunctions.put(
			"legalCaseId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getLegalCaseId();
				}

			});
		attributeSetterBiConsumers.put(
			"legalCaseId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object legalCaseId) {
					legalCase.setLegalCaseId((Long)legalCaseId);
				}

			});
		attributeGetterFunctions.put(
			"groupId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getGroupId();
				}

			});
		attributeSetterBiConsumers.put(
			"groupId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object groupId) {
					legalCase.setGroupId((Long)groupId);
				}

			});
		attributeGetterFunctions.put(
			"companyId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getCompanyId();
				}

			});
		attributeSetterBiConsumers.put(
			"companyId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object companyId) {
					legalCase.setCompanyId((Long)companyId);
				}

			});
		attributeGetterFunctions.put(
			"userId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getUserId();
				}

			});
		attributeSetterBiConsumers.put(
			"userId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object userId) {
					legalCase.setUserId((Long)userId);
				}

			});
		attributeGetterFunctions.put(
			"userName",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getUserName();
				}

			});
		attributeSetterBiConsumers.put(
			"userName",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object userName) {
					legalCase.setUserName((String)userName);
				}

			});
		attributeGetterFunctions.put(
			"createDate",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getCreateDate();
				}

			});
		attributeSetterBiConsumers.put(
			"createDate",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object createDate) {
					legalCase.setCreateDate((Date)createDate);
				}

			});
		attributeGetterFunctions.put(
			"modifiedDate",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getModifiedDate();
				}

			});
		attributeSetterBiConsumers.put(
			"modifiedDate",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object modifiedDate) {
					legalCase.setModifiedDate((Date)modifiedDate);
				}

			});
		attributeGetterFunctions.put(
			"status",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getStatus();
				}

			});
		attributeSetterBiConsumers.put(
			"status",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object status) {
					legalCase.setStatus((Integer)status);
				}

			});
		attributeGetterFunctions.put(
			"statusByUserId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getStatusByUserId();
				}

			});
		attributeSetterBiConsumers.put(
			"statusByUserId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object statusByUserId) {
					legalCase.setStatusByUserId((Long)statusByUserId);
				}

			});
		attributeGetterFunctions.put(
			"statusByUserName",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getStatusByUserName();
				}

			});
		attributeSetterBiConsumers.put(
			"statusByUserName",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(
					LegalCase legalCase, Object statusByUserName) {

					legalCase.setStatusByUserName((String)statusByUserName);
				}

			});
		attributeGetterFunctions.put(
			"statusDate",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getStatusDate();
				}

			});
		attributeSetterBiConsumers.put(
			"statusDate",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object statusDate) {
					legalCase.setStatusDate((Date)statusDate);
				}

			});
		attributeGetterFunctions.put(
			"title",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getTitle();
				}

			});
		attributeSetterBiConsumers.put(
			"title",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object title) {
					legalCase.setTitle((String)title);
				}

			});
		attributeGetterFunctions.put(
			"description",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getDescription();
				}

			});
		attributeSetterBiConsumers.put(
			"description",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object description) {
					legalCase.setDescription((String)description);
				}

			});
		attributeGetterFunctions.put(
			"decisionDate",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getDecisionDate();
				}

			});
		attributeSetterBiConsumers.put(
			"decisionDate",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object decisionDate) {
					legalCase.setDecisionDate((Date)decisionDate);
				}

			});
		attributeGetterFunctions.put(
			"countryCategoryId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getCountryCategoryId();
				}

			});
		attributeSetterBiConsumers.put(
			"countryCategoryId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(
					LegalCase legalCase, Object countryCategoryId) {

					legalCase.setCountryCategoryId((Long)countryCategoryId);
				}

			});
		attributeGetterFunctions.put(
			"subareaCategoryId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getSubareaCategoryId();
				}

			});
		attributeSetterBiConsumers.put(
			"subareaCategoryId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(
					LegalCase legalCase, Object subareaCategoryId) {

					legalCase.setSubareaCategoryId((Long)subareaCategoryId);
				}

			});
		attributeGetterFunctions.put(
			"summaryFileEntryId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getSummaryFileEntryId();
				}

			});
		attributeSetterBiConsumers.put(
			"summaryFileEntryId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(
					LegalCase legalCase, Object summaryFileEntryId) {

					legalCase.setSummaryFileEntryId((Long)summaryFileEntryId);
				}

			});
		attributeGetterFunctions.put(
			"judgementFileEntryId",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getJudgementFileEntryId();
				}

			});
		attributeSetterBiConsumers.put(
			"judgementFileEntryId",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(
					LegalCase legalCase, Object judgementFileEntryId) {

					legalCase.setJudgementFileEntryId(
						(Long)judgementFileEntryId);
				}

			});
		attributeGetterFunctions.put(
			"url",
			new Function<LegalCase, Object>() {

				@Override
				public Object apply(LegalCase legalCase) {
					return legalCase.getUrl();
				}

			});
		attributeSetterBiConsumers.put(
			"url",
			new BiConsumer<LegalCase, Object>() {

				@Override
				public void accept(LegalCase legalCase, Object url) {
					legalCase.setUrl((String)url);
				}

			});

		_attributeGetterFunctions = Collections.unmodifiableMap(
			attributeGetterFunctions);
		_attributeSetterBiConsumers = Collections.unmodifiableMap(
			(Map)attributeSetterBiConsumers);
	}

	@Override
	public String getUuid() {
		if (_uuid == null) {
			return "";
		}
		else {
			return _uuid;
		}
	}

	@Override
	public void setUuid(String uuid) {
		_columnBitmask |= UUID_COLUMN_BITMASK;

		if (_originalUuid == null) {
			_originalUuid = _uuid;
		}

		_uuid = uuid;
	}

	public String getOriginalUuid() {
		return GetterUtil.getString(_originalUuid);
	}

	@Override
	public long getLegalCaseId() {
		return _legalCaseId;
	}

	@Override
	public void setLegalCaseId(long legalCaseId) {
		_legalCaseId = legalCaseId;
	}

	@Override
	public long getGroupId() {
		return _groupId;
	}

	@Override
	public void setGroupId(long groupId) {
		_columnBitmask |= GROUPID_COLUMN_BITMASK;

		if (!_setOriginalGroupId) {
			_setOriginalGroupId = true;

			_originalGroupId = _groupId;
		}

		_groupId = groupId;
	}

	public long getOriginalGroupId() {
		return _originalGroupId;
	}

	@Override
	public long getCompanyId() {
		return _companyId;
	}

	@Override
	public void setCompanyId(long companyId) {
		_columnBitmask |= COMPANYID_COLUMN_BITMASK;

		if (!_setOriginalCompanyId) {
			_setOriginalCompanyId = true;

			_originalCompanyId = _companyId;
		}

		_companyId = companyId;
	}

	public long getOriginalCompanyId() {
		return _originalCompanyId;
	}

	@Override
	public long getUserId() {
		return _userId;
	}

	@Override
	public void setUserId(long userId) {
		_userId = userId;
	}

	@Override
	public String getUserUuid() {
		try {
			User user = UserLocalServiceUtil.getUserById(getUserId());

			return user.getUuid();
		}
		catch (PortalException pe) {
			return "";
		}
	}

	@Override
	public void setUserUuid(String userUuid) {
	}

	@Override
	public String getUserName() {
		if (_userName == null) {
			return "";
		}
		else {
			return _userName;
		}
	}

	@Override
	public void setUserName(String userName) {
		_userName = userName;
	}

	@Override
	public Date getCreateDate() {
		return _createDate;
	}

	@Override
	public void setCreateDate(Date createDate) {
		_createDate = createDate;
	}

	@Override
	public Date getModifiedDate() {
		return _modifiedDate;
	}

	public boolean hasSetModifiedDate() {
		return _setModifiedDate;
	}

	@Override
	public void setModifiedDate(Date modifiedDate) {
		_setModifiedDate = true;

		_modifiedDate = modifiedDate;
	}

	@Override
	public int getStatus() {
		return _status;
	}

	@Override
	public void setStatus(int status) {
		_status = status;
	}

	@Override
	public long getStatusByUserId() {
		return _statusByUserId;
	}

	@Override
	public void setStatusByUserId(long statusByUserId) {
		_statusByUserId = statusByUserId;
	}

	@Override
	public String getStatusByUserUuid() {
		try {
			User user = UserLocalServiceUtil.getUserById(getStatusByUserId());

			return user.getUuid();
		}
		catch (PortalException pe) {
			return "";
		}
	}

	@Override
	public void setStatusByUserUuid(String statusByUserUuid) {
	}

	@Override
	public String getStatusByUserName() {
		if (_statusByUserName == null) {
			return "";
		}
		else {
			return _statusByUserName;
		}
	}

	@Override
	public void setStatusByUserName(String statusByUserName) {
		_statusByUserName = statusByUserName;
	}

	@Override
	public Date getStatusDate() {
		return _statusDate;
	}

	@Override
	public void setStatusDate(Date statusDate) {
		_statusDate = statusDate;
	}

	@Override
	public String getTitle() {
		if (_title == null) {
			return "";
		}
		else {
			return _title;
		}
	}

	@Override
	public void setTitle(String title) {
		_title = title;
	}

	@Override
	public String getDescription() {
		if (_description == null) {
			return "";
		}
		else {
			return _description;
		}
	}

	@Override
	public void setDescription(String description) {
		_description = description;
	}

	@Override
	public Date getDecisionDate() {
		return _decisionDate;
	}

	@Override
	public void setDecisionDate(Date decisionDate) {
		_columnBitmask = -1L;

		_decisionDate = decisionDate;
	}

	@Override
	public long getCountryCategoryId() {
		return _countryCategoryId;
	}

	@Override
	public void setCountryCategoryId(long countryCategoryId) {
		_columnBitmask |= COUNTRYCATEGORYID_COLUMN_BITMASK;

		if (!_setOriginalCountryCategoryId) {
			_setOriginalCountryCategoryId = true;

			_originalCountryCategoryId = _countryCategoryId;
		}

		_countryCategoryId = countryCategoryId;
	}

	public long getOriginalCountryCategoryId() {
		return _originalCountryCategoryId;
	}

	@Override
	public long getSubareaCategoryId() {
		return _subareaCategoryId;
	}

	@Override
	public void setSubareaCategoryId(long subareaCategoryId) {
		_columnBitmask |= SUBAREACATEGORYID_COLUMN_BITMASK;

		if (!_setOriginalSubareaCategoryId) {
			_setOriginalSubareaCategoryId = true;

			_originalSubareaCategoryId = _subareaCategoryId;
		}

		_subareaCategoryId = subareaCategoryId;
	}

	public long getOriginalSubareaCategoryId() {
		return _originalSubareaCategoryId;
	}

	@Override
	public long getSummaryFileEntryId() {
		return _summaryFileEntryId;
	}

	@Override
	public void setSummaryFileEntryId(long summaryFileEntryId) {
		_summaryFileEntryId = summaryFileEntryId;
	}

	@Override
	public long getJudgementFileEntryId() {
		return _judgementFileEntryId;
	}

	@Override
	public void setJudgementFileEntryId(long judgementFileEntryId) {
		_judgementFileEntryId = judgementFileEntryId;
	}

	@Override
	public String getUrl() {
		if (_url == null) {
			return "";
		}
		else {
			return _url;
		}
	}

	@Override
	public void setUrl(String url) {
		_url = url;
	}

	@Override
	public StagedModelType getStagedModelType() {
		return new StagedModelType(
			PortalUtil.getClassNameId(LegalCase.class.getName()));
	}

	@Override
	public boolean isApproved() {
		if (getStatus() == WorkflowConstants.STATUS_APPROVED) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isDenied() {
		if (getStatus() == WorkflowConstants.STATUS_DENIED) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isDraft() {
		if (getStatus() == WorkflowConstants.STATUS_DRAFT) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isExpired() {
		if (getStatus() == WorkflowConstants.STATUS_EXPIRED) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isInactive() {
		if (getStatus() == WorkflowConstants.STATUS_INACTIVE) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isIncomplete() {
		if (getStatus() == WorkflowConstants.STATUS_INCOMPLETE) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isPending() {
		if (getStatus() == WorkflowConstants.STATUS_PENDING) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public boolean isScheduled() {
		if (getStatus() == WorkflowConstants.STATUS_SCHEDULED) {
			return true;
		}
		else {
			return false;
		}
	}

	public long getColumnBitmask() {
		return _columnBitmask;
	}

	@Override
	public ExpandoBridge getExpandoBridge() {
		return ExpandoBridgeFactoryUtil.getExpandoBridge(
			getCompanyId(), LegalCase.class.getName(), getPrimaryKey());
	}

	@Override
	public void setExpandoBridgeAttributes(ServiceContext serviceContext) {
		ExpandoBridge expandoBridge = getExpandoBridge();

		expandoBridge.setAttributes(serviceContext);
	}

	@Override
	public LegalCase toEscapedModel() {
		if (_escapedModel == null) {
			_escapedModel = _escapedModelProxyProviderFunction.apply(
				new AutoEscapeBeanHandler(this));
		}

		return _escapedModel;
	}

	@Override
	public Object clone() {
		LegalCaseImpl legalCaseImpl = new LegalCaseImpl();

		legalCaseImpl.setUuid(getUuid());
		legalCaseImpl.setLegalCaseId(getLegalCaseId());
		legalCaseImpl.setGroupId(getGroupId());
		legalCaseImpl.setCompanyId(getCompanyId());
		legalCaseImpl.setUserId(getUserId());
		legalCaseImpl.setUserName(getUserName());
		legalCaseImpl.setCreateDate(getCreateDate());
		legalCaseImpl.setModifiedDate(getModifiedDate());
		legalCaseImpl.setStatus(getStatus());
		legalCaseImpl.setStatusByUserId(getStatusByUserId());
		legalCaseImpl.setStatusByUserName(getStatusByUserName());
		legalCaseImpl.setStatusDate(getStatusDate());
		legalCaseImpl.setTitle(getTitle());
		legalCaseImpl.setDescription(getDescription());
		legalCaseImpl.setDecisionDate(getDecisionDate());
		legalCaseImpl.setCountryCategoryId(getCountryCategoryId());
		legalCaseImpl.setSubareaCategoryId(getSubareaCategoryId());
		legalCaseImpl.setSummaryFileEntryId(getSummaryFileEntryId());
		legalCaseImpl.setJudgementFileEntryId(getJudgementFileEntryId());
		legalCaseImpl.setUrl(getUrl());

		legalCaseImpl.resetOriginalValues();

		return legalCaseImpl;
	}

	@Override
	public int compareTo(LegalCase legalCase) {
		int value = 0;

		value = DateUtil.compareTo(
			getDecisionDate(), legalCase.getDecisionDate());

		value = value * -1;

		if (value != 0) {
			return value;
		}

		return 0;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}

		if (!(obj instanceof LegalCase)) {
			return false;
		}

		LegalCase legalCase = (LegalCase)obj;

		long primaryKey = legalCase.getPrimaryKey();

		if (getPrimaryKey() == primaryKey) {
			return true;
		}
		else {
			return false;
		}
	}

	@Override
	public int hashCode() {
		return (int)getPrimaryKey();
	}

	@Override
	public boolean isEntityCacheEnabled() {
		return ENTITY_CACHE_ENABLED;
	}

	@Override
	public boolean isFinderCacheEnabled() {
		return FINDER_CACHE_ENABLED;
	}

	@Override
	public void resetOriginalValues() {
		LegalCaseModelImpl legalCaseModelImpl = this;

		legalCaseModelImpl._originalUuid = legalCaseModelImpl._uuid;

		legalCaseModelImpl._originalGroupId = legalCaseModelImpl._groupId;

		legalCaseModelImpl._setOriginalGroupId = false;

		legalCaseModelImpl._originalCompanyId = legalCaseModelImpl._companyId;

		legalCaseModelImpl._setOriginalCompanyId = false;

		legalCaseModelImpl._setModifiedDate = false;

		legalCaseModelImpl._originalCountryCategoryId =
			legalCaseModelImpl._countryCategoryId;

		legalCaseModelImpl._setOriginalCountryCategoryId = false;

		legalCaseModelImpl._originalSubareaCategoryId =
			legalCaseModelImpl._subareaCategoryId;

		legalCaseModelImpl._setOriginalSubareaCategoryId = false;

		legalCaseModelImpl._columnBitmask = 0;
	}

	@Override
	public CacheModel<LegalCase> toCacheModel() {
		LegalCaseCacheModel legalCaseCacheModel = new LegalCaseCacheModel();

		legalCaseCacheModel.uuid = getUuid();

		String uuid = legalCaseCacheModel.uuid;

		if ((uuid != null) && (uuid.length() == 0)) {
			legalCaseCacheModel.uuid = null;
		}

		legalCaseCacheModel.legalCaseId = getLegalCaseId();

		legalCaseCacheModel.groupId = getGroupId();

		legalCaseCacheModel.companyId = getCompanyId();

		legalCaseCacheModel.userId = getUserId();

		legalCaseCacheModel.userName = getUserName();

		String userName = legalCaseCacheModel.userName;

		if ((userName != null) && (userName.length() == 0)) {
			legalCaseCacheModel.userName = null;
		}

		Date createDate = getCreateDate();

		if (createDate != null) {
			legalCaseCacheModel.createDate = createDate.getTime();
		}
		else {
			legalCaseCacheModel.createDate = Long.MIN_VALUE;
		}

		Date modifiedDate = getModifiedDate();

		if (modifiedDate != null) {
			legalCaseCacheModel.modifiedDate = modifiedDate.getTime();
		}
		else {
			legalCaseCacheModel.modifiedDate = Long.MIN_VALUE;
		}

		legalCaseCacheModel.status = getStatus();

		legalCaseCacheModel.statusByUserId = getStatusByUserId();

		legalCaseCacheModel.statusByUserName = getStatusByUserName();

		String statusByUserName = legalCaseCacheModel.statusByUserName;

		if ((statusByUserName != null) && (statusByUserName.length() == 0)) {
			legalCaseCacheModel.statusByUserName = null;
		}

		Date statusDate = getStatusDate();

		if (statusDate != null) {
			legalCaseCacheModel.statusDate = statusDate.getTime();
		}
		else {
			legalCaseCacheModel.statusDate = Long.MIN_VALUE;
		}

		legalCaseCacheModel.title = getTitle();

		String title = legalCaseCacheModel.title;

		if ((title != null) && (title.length() == 0)) {
			legalCaseCacheModel.title = null;
		}

		legalCaseCacheModel.description = getDescription();

		String description = legalCaseCacheModel.description;

		if ((description != null) && (description.length() == 0)) {
			legalCaseCacheModel.description = null;
		}

		Date decisionDate = getDecisionDate();

		if (decisionDate != null) {
			legalCaseCacheModel.decisionDate = decisionDate.getTime();
		}
		else {
			legalCaseCacheModel.decisionDate = Long.MIN_VALUE;
		}

		legalCaseCacheModel.countryCategoryId = getCountryCategoryId();

		legalCaseCacheModel.subareaCategoryId = getSubareaCategoryId();

		legalCaseCacheModel.summaryFileEntryId = getSummaryFileEntryId();

		legalCaseCacheModel.judgementFileEntryId = getJudgementFileEntryId();

		legalCaseCacheModel.url = getUrl();

		String url = legalCaseCacheModel.url;

		if ((url != null) && (url.length() == 0)) {
			legalCaseCacheModel.url = null;
		}

		return legalCaseCacheModel;
	}

	@Override
	public String toString() {
		Map<String, Function<LegalCase, Object>> attributeGetterFunctions =
			getAttributeGetterFunctions();

		StringBundler sb = new StringBundler(
			4 * attributeGetterFunctions.size() + 2);

		sb.append("{");

		for (Map.Entry<String, Function<LegalCase, Object>> entry :
				attributeGetterFunctions.entrySet()) {

			String attributeName = entry.getKey();
			Function<LegalCase, Object> attributeGetterFunction =
				entry.getValue();

			sb.append(attributeName);
			sb.append("=");
			sb.append(attributeGetterFunction.apply((LegalCase)this));
			sb.append(", ");
		}

		if (sb.index() > 1) {
			sb.setIndex(sb.index() - 1);
		}

		sb.append("}");

		return sb.toString();
	}

	@Override
	public String toXmlString() {
		Map<String, Function<LegalCase, Object>> attributeGetterFunctions =
			getAttributeGetterFunctions();

		StringBundler sb = new StringBundler(
			5 * attributeGetterFunctions.size() + 4);

		sb.append("<model><model-name>");
		sb.append(getModelClassName());
		sb.append("</model-name>");

		for (Map.Entry<String, Function<LegalCase, Object>> entry :
				attributeGetterFunctions.entrySet()) {

			String attributeName = entry.getKey();
			Function<LegalCase, Object> attributeGetterFunction =
				entry.getValue();

			sb.append("<column><column-name>");
			sb.append(attributeName);
			sb.append("</column-name><column-value><![CDATA[");
			sb.append(attributeGetterFunction.apply((LegalCase)this));
			sb.append("]]></column-value></column>");
		}

		sb.append("</model>");

		return sb.toString();
	}

	private static final Function<InvocationHandler, LegalCase>
		_escapedModelProxyProviderFunction = _getProxyProviderFunction();

	private String _uuid;
	private String _originalUuid;
	private long _legalCaseId;
	private long _groupId;
	private long _originalGroupId;
	private boolean _setOriginalGroupId;
	private long _companyId;
	private long _originalCompanyId;
	private boolean _setOriginalCompanyId;
	private long _userId;
	private String _userName;
	private Date _createDate;
	private Date _modifiedDate;
	private boolean _setModifiedDate;
	private int _status;
	private long _statusByUserId;
	private String _statusByUserName;
	private Date _statusDate;
	private String _title;
	private String _description;
	private Date _decisionDate;
	private long _countryCategoryId;
	private long _originalCountryCategoryId;
	private boolean _setOriginalCountryCategoryId;
	private long _subareaCategoryId;
	private long _originalSubareaCategoryId;
	private boolean _setOriginalSubareaCategoryId;
	private long _summaryFileEntryId;
	private long _judgementFileEntryId;
	private String _url;
	private long _columnBitmask;
	private LegalCase _escapedModel;

}